package fr.ynerant.tarot.ui.games;

import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProviders;

import fr.ynerant.tarot.Game;
import fr.ynerant.tarot.MainActivity;
import fr.ynerant.tarot.Player;
import fr.ynerant.tarot.R;
import fr.ynerant.tarot.ui.home.HomeFragment;

public class GameInfoFragment extends Fragment {

	public View onCreateView(@NonNull LayoutInflater inflater,
							 ViewGroup container, final Bundle savedInstanceState) {
		ViewModelProviders.of(this).get(GameInfoModel.class);
		final View root = inflater.inflate(R.layout.fragment_game_info, container, false);

		if (PreferenceManager.getDefaultSharedPreferences(MainActivity.INSTANCE).getString("token", null) == null) {
			//noinspection ConstantConditions
			getFragmentManager().beginTransaction().replace(R.id.nav_host_fragment, new HomeFragment(), "Se connecter").commit();
			return root;
		}

		Game game = Game.getGameById(getArguments().getInt("gameId"));

		TextView points1 = root.findViewById(R.id.player1_points);
		TextView points2 = root.findViewById(R.id.player2_points);
		TextView points3 = root.findViewById(R.id.player3_points);
		TextView points4 = root.findViewById(R.id.player4_points);
		TextView points5 = root.findViewById(R.id.player5_points);
		TextView points6 = root.findViewById(R.id.player6_points);
		TextView[] points = new TextView[]{points1, points2, points3, points4, points5, points6};
		TextView points1Text = root.findViewById(R.id.player1_points_text);
		TextView points2Text = root.findViewById(R.id.player2_points_text);
		TextView points3Text = root.findViewById(R.id.player3_points_text);
		TextView points4Text = root.findViewById(R.id.player4_points_text);
		TextView points5Text = root.findViewById(R.id.player5_points_text);
		TextView points6Text = root.findViewById(R.id.player6_points_text);
		TextView[] pointsText = new TextView[]{points1Text, points2Text, points3Text, points4Text, points5Text, points6Text};

		for (int i = 0; i < game.getGameType().getNbPlayers(); ++i) {
			System.out.println(i + ", " + game.getGameType());
			pointsText[i].setVisibility(View.VISIBLE);
			pointsText[i].setText(game.getPlayers().get(i).getName());
			points[i].setVisibility(View.VISIBLE);
			points[i].setText(String.valueOf(game.getPoints(i)));
		}

		TextView attacker = root.findViewById(R.id.attacker);
		TextView follower = root.findViewById(R.id.follower);
		LinearLayout followerLayout = root.findViewById(R.id.follower_layout);

		attacker.setText(game.getAttacker().getName());

		if (game.getGameType() == Game.GameType.FIVE_PLAYERS || game.getGameType() == Game.GameType.SIX_PLAYERS) {
			followerLayout.setVisibility(View.VISIBLE);
			follower.setText(game.getFollower().getName());
		}

		TextView bet = root.findViewById(R.id.bet);
		bet.setText(game.getBet().toString());

		TextView ends = root.findViewById(R.id.ends);
		ends.setText(game.getEnds() + " bout" + (game.getEnds() >= 2 ? "s" : ""));

		TextView attackScore = root.findViewById(R.id.attack_score);
		attackScore.setText(String.valueOf(game.getAttackScore()));

		TextView chelem = root.findViewById(R.id.chelem);
		chelem.setText((game.isChelemAnnounced() ? "" : "non ") + "annoncé, " + (game.isChelemRealized() ? "" : "non ") + "réalisé");

		TextView littleEnd = root.findViewById(R.id.little_end);
		littleEnd.setText(game.getLittleEnd() == 0 ? "Non" : game.getPlayers().get(game.getLittleEnd() - 1).getName());

		TextView handles = root.findViewById(R.id.handles);
		String handlesStr = "";
		for (int i = 0; i < game.getGameType().getNbPlayers(); ++i) {
			if (game.getHandles().get(i) > 0)
				handlesStr += game.getPlayers().get(i) + " (" + (game.getHandles().get(i) == 1 ? "simple" : game.getHandles().get(i) == 2 ? "double" : "triple") + "), ";
		}
		if (handlesStr.isEmpty())
			handlesStr = "Pas de poignée";
		else
			handlesStr = handlesStr.substring(0, handlesStr.length() - 2);
		handles.setText(handlesStr);

		TextView miseries = root.findViewById(R.id.miseries);
		String miseriesStr = "";
		for (int i = 0; i < game.getGameType().getNbPlayers(); ++i) {
			if (game.getMiseries().get(i))
				miseriesStr += game.getPlayers().get(i) + ", ";
		}
		if (miseriesStr.isEmpty())
			miseriesStr = "Pas de misère";
		else
			miseriesStr = miseriesStr.substring(0, miseriesStr.length() - 2);
		miseries.setText(miseriesStr);

		return root;
	}
}