package fr.ynerant.tarot.ui.games;

import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListAdapter;
import android.widget.ListView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProviders;

import fr.ynerant.tarot.Game;
import fr.ynerant.tarot.MainActivity;
import fr.ynerant.tarot.Player;
import fr.ynerant.tarot.R;
import fr.ynerant.tarot.ui.home.HomeFragment;
import fr.ynerant.tarot.ui.stats.PersonalStatsFragment;

public class GamesMenuFragment extends Fragment {

	public View onCreateView(@NonNull LayoutInflater inflater,
							 ViewGroup container, final Bundle savedInstanceState) {
		ViewModelProviders.of(this).get(GamesMenuModel.class);
		final View root = inflater.inflate(R.layout.fragment_games_menu, container, false);

		if (PreferenceManager.getDefaultSharedPreferences(MainActivity.INSTANCE).getString("token", null) == null) {
			//noinspection ConstantConditions
			getFragmentManager().beginTransaction().replace(R.id.nav_games, new HomeFragment(), "Se connecter").commit();
			return root;
		}

		ListView gameList = root.findViewById(R.id.game_list);
		final ListAdapter adapter = new ArrayAdapter<>(getContext(), android.R.layout.simple_expandable_list_item_1, Game.getAllGames());
		gameList.setAdapter(adapter);

		gameList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				Game game = (Game) adapter.getItem(position);
				GameInfoFragment fragment = new GameInfoFragment();
				Bundle bundle = new Bundle();
				bundle.putInt("gameId", game.getId());
				fragment.setArguments(bundle);
				//noinspection ConstantConditions
				getFragmentManager().beginTransaction().replace(R.id.nav_host_fragment, fragment, "Détails d'une partie")
						.addToBackStack("Détails d'une partie").commit();
			}
		});

		return root;
	}
}